const tabsList = document.getElementById('tabslist');

function firstUnpinnedTab(tabs) {
  for (var tab of tabs) {
    if (!tab.pinned) {
      return tab.index;
    }
  }
}

/**
 * listTabs to switch to
 */
function listTabs() {
dump("listTabs : "+Window+"    "+(typeof Window)+"\n");
  getCurrentWindowTabs().then((tabs) => {
    let currentTabs = document.createDocumentFragment();

    for (let tab of tabs) {
      var closebutton = browser.extension.getURL("icons/button_close_12.png");

      if (tab.hidden === true) {
        //continue;
      }

dump("    >>>> id : "+tab.id+"    hidden : "+tab.hidden+"    title : "+tab.title+"\n");
//dump("    >>>> "+tab.index+"\n");

      var menuitem = document.createElement('div');
      var itemicon = document.createElement('div');
      var imageicon = document.createElement('img');
      var itemtext = document.createElement('div');
      var itemclose = document.createElement('div');
      var imageclose = document.createElement('img');

      menuitem.tabid = tab.id;
      menuitem.classList.add("menuitem");

      itemicon.classList.add("itemicon");
      itemicon.menuitem = menuitem;

      itemtext.textContent = tab.title || tab.id;
      itemtext.classList.add("itemtext");
      itemtext.menuitem = menuitem;

      itemclose.classList.add("itemclose");
      itemclose.style.opacity = '0.5';
      itemclose.menuitem = menuitem;

      imageicon.classList.add("imageicon");
      imageicon.src = tab.favIconUrl;
      imageicon.setAttribute("width", "12");
      imageicon.setAttribute("height", "12");
      imageicon.menuitem = menuitem;

      imageclose.classList.add("imageclose");
      imageclose.src = closebutton;
      imageclose.setAttribute("width", "10");
      imageclose.setAttribute("height", "10");
      imageclose.menuitem = menuitem;

      itemicon.appendChild(imageicon);
      itemclose.appendChild(imageclose);

      menuitem.appendChild(itemicon);
      menuitem.appendChild(itemtext);
      menuitem.appendChild(itemclose);
      currentTabs.appendChild(menuitem);
    }

    tabsList.appendChild(currentTabs);

  });
}

function getCurrentWindowTabs() {
  return browser.tabs.query({currentWindow: true});
}

function refreshTabsList() {
  var cs = getComputedStyle(tabsList,null);
  var tabsListwid = cs.getPropertyValue("width");
  var tabsListht = cs.getPropertyValue("height");
dump(" >>>> "+tabsListwid+"    "+tabsListht+"\n");
  var nodes = tabsList.childNodes;
  var len = nodes.length;
  for (var i=0;i<len;i++) {
    tabsList.removeChild(nodes[0]);
  }
  listTabs();
  tabsList.style.width = "auto";
  tabsList.style.height = "auto";
}

var isMenuitemSelected = false;
var lastSelectedMenuitem = null;
function handleMenuitemSelect(e) {
  var item = e.target;
//dump("handleMenuitemSelect ::: "+item.className+"    "+item.menuitem+"\n");
  var menuitem = item.menuitem || item;
  menuitem.classList.add("menuitemselected");
  menuitem.isSelected = true;

  // If shiftKey and there has already been a menuitem selected,
  // select a range between the two.
  if (e.shiftKey && lastSelectedMenuitem) {
    selectRange(lastSelectedMenuitem, menuitem);
  }

  // global concerns
  isMenuitemSelected = true;
  tabsList.setAttribute("ismenuitemselected", "true");
  lastSelectedMenuitem = menuitem;
}

function selectRange(menuitem1, menuitem2) {
//dump("selectRange\n");
  // Selects a range between menuitem1 and menuitem2, regardless of which
  // is preceding.
  if (menuitem1 == menuitem2) {
    return;
  }

  var select = false;
  var nodes = tabsList.childNodes;
  var len = nodes.length;
  for (var i=0;i<len;i++) {
    var menuitem = nodes[i];
    if (!select) {
      if (menuitem == menuitem1 || menuitem == menuitem2) {
        select = true;
      }
    } else {
      if (menuitem == menuitem1 || menuitem == menuitem2) {
        return;
      }
      menuitem.classList.add("menuitemselected");
      menuitem.isSelected = true;
    }
  }
}

function clearMenuitemSelection() {
//dump("clearMenuitemSelection\n");
  var nodes = tabsList.childNodes;
  var len = nodes.length;
  for (var i=0;i<len;i++) {
    var menuitem = nodes[i];
    menuitem.classList.remove("menuitemselected");
    menuitem.isSelected = false;
  }
  isMenuitemSelected = false;
  tabsList.removeAttribute("ismenuitemselected");
  lastSelectedMenuitem = null;
}

var isMenuitemDragListener = false;
function beginMenuitemDrag() {
//dump("beginMenuitemDrag\n");
  var nodes = tabsList.childNodes;
  var len = nodes.length;
  var count = 0;
  for (var i=0;i<len;i++) {
    var menuitem = nodes[i];
    if (menuitem.isSelected) {
      count++;
    }
  }
  document.addEventListener("mousemove", dragMenuitem);
  isMenuitemDragListener = true;
}

var isMenuitemDragging = false;
function dragMenuitem(e) {
  isMenuitemDragging = true;
//dump("dragMenuitem : "+e.clientX+"    "+e.clientY+"\n");
  tabsList.setAttribute("dragging", "true");
}

function endMenuitemDrag() {
  isMenuitemDragging = false;
//dump("endMenuitemDrag\n");
  document.removeEventListener("mousemove", dragMenuitem);
  isMenuitemDragListener = false;
  tabsList.removeAttribute("dragging");
}

function dropMenuitem(e) {
  var menuitem = e.target.menuitem || e.target;
  if (!menuitem) {
    return;
  }

  var ids = getSelectedMenuitems(true);

dump("dropMenuitem 1 : "+ids.length+"\n");

  if (!ids.length) {
    return;
  }

  var tabid = menuitem.nextSibling ? menuitem.nextSibling.tabid : menuitem.tabid;

  var tabinfo = browser.tabs.get(tabid);
  tabinfo.then(function(tab) {
dump("dropMenuitem 2 : "+tab.index+"\n");
    var movepromise = browser.tabs.move(ids, { index : tab.index });
    movepromise.then(function() {
      refreshTabsList();
    });
  });
}

function getSelectedMenuitems(returnTabIds) {
  var data = [];
  var nodes = tabsList.childNodes;
  var len = nodes.length;
  for (var i=0;i<len;i++) {
    var menuitem = nodes[i];
    if (menuitem.isSelected) {
      data.push(returnTabIds ? menuitem.tabid : menuitem);
    }
  }
  return data;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// EVENT LISTENERS

document.addEventListener("DOMContentLoaded", listTabs);

var clearSelectionOnMouseRelease = false;
document.addEventListener("mousedown", function(e) {
  e.preventDefault();
  if (e.ctrlKey || e.metaKey || e.shiftKey) {
    handleMenuitemSelect(e);
  } else if (isMenuitemSelected) {
    clearSelectionOnMouseRelease = true;
    beginMenuitemDrag();
  }
});

var inhibitClick = false;
document.addEventListener("mouseup", function(e) {
//dump("mouseup : "+isMenuitemDragging+"    "+clearSelectionOnMouseRelease+"\n");

  // Important: This must preceed code that calls clearMenuitemSelection() !!!
  if (isMenuitemDragging) {
    dropMenuitem(e);
  }

  if (clearSelectionOnMouseRelease) {
    clearSelectionOnMouseRelease = false;
    clearMenuitemSelection();
    // If we released on a plain click, the click event will immediately be
    // fired next, but we want to inhibit any other action (tab select or close).
    // If we released on a drag, the click event won't get fired right away, so
    // we don't want to inhibitClick on the following click.
    inhibitClick = !isMenuitemDragging;
  }

  // Important: This must succeed the above, otherwise isMenuitemDragging will
  // get cleared, which is needed for the test above.
  if (isMenuitemDragListener) {
    endMenuitemDrag();
  }

});

document.addEventListener("click", function(e) {

//dump("click ::: "+inhibitClick+"    isMenuitemSelected : "+isMenuitemSelected+"\n");


  if (inhibitClick) {
    inhibitClick = false;
    return;
  }

  if (isMenuitemSelected) {
    return;
  }

  if (e.target.className == "imageclose") {
    var menuitem = e.target.menuitem;
    browser.tabs.remove(menuitem.tabid);
    menuitem.parentNode.removeChild(menuitem);
    return;
  } else if (e.target.menuitem || e.target.className == "menuitem") {
    var menuitem = e.target.menuitem || e.target;
    browser.tabs.update(menuitem.tabid, { active: true });
    return;
  }






  function callOnActiveTab(callback) {
    getCurrentWindowTabs().then((tabs) => {
      for (var tab of tabs) {
        if (tab.active) {
          callback(tab, tabs);
        }
      }
    });
  }

  if (e.target.id === "tabs-move-beginning") {
    callOnActiveTab((tab, tabs) => {
      var index = 0;
      if (!tab.pinned) {
        index = firstUnpinnedTab(tabs);
      }
      console.log(`moving ${tab.id} to ${index}`)
      browser.tabs.move([tab.id], {index});
    });
  }

  if (e.target.id === "tabs-move-end") {
    callOnActiveTab((tab, tabs) => {
      var index = -1;
      if (tab.pinned) {
        var lastPinnedTab = Math.max(0, firstUnpinnedTab(tabs) - 1);
        index = lastPinnedTab;
      }
      browser.tabs.move([tab.id], {index});
    });
  }

  else if (e.target.id === "tabs-duplicate") {
    callOnActiveTab((tab) => {
      browser.tabs.duplicate(tab.id);
    });
  }

  else if (e.target.id === "tabs-reload") {
    callOnActiveTab((tab) => {
      browser.tabs.reload(tab.id);
    });
  }

  else if (e.target.id === "tabs-remove") {
    callOnActiveTab((tab) => {
      browser.tabs.remove(tab.id);
    });
  }

  else if (e.target.id === "tabs-create") {
    browser.tabs.create({url: "https://developer.mozilla.org/en-US/Add-ons/WebExtensions"});
  }

  else if (e.target.id === "tabs-alertinfo") {
    callOnActiveTab((tab) => {
      let props = "";
      for (let item in tab) {
        props += `${ item } = ${ tab[item] } \n`;
      }
      alert(props);
    });
  }

  // Currently (11/2/2016) only supported by Chrome
  else if (e.target.id === "tabs-highlight") { // highlights current tab and next tab (cycles back to first tab if current tab is the last one)
    callOnActiveTab((tab, tabs) => {
      next = (tab.index+1) % tabs.length;
      browser.tabs.highlight({tabs:[tab.index, next]});
    });
  }

  else if (e.target.classList.contains('switch-tabs')) {
    var tabId = +e.target.getAttribute('href');

    chrome.tabs.query({
      currentWindow: true
    }, function(tabs) {
      for (var tab of tabs) {
        if (tab.id === tabId) {
          chrome.tabs.update(tabId, {
              active: true
          });
        }
      }
    });
  }

  e.preventDefault();
});

//onRemoved listener. fired when tab is removed
browser.tabs.onRemoved.addListener(function(tabId, removeInfo){
  console.log(`The tab with id: ${tabId}, is closing`);

  if(removeInfo.isWindowClosing) {
    console.log(`Its window is also closing.`);
  } else {
    console.log(`Its window is not closing`);
  }
});

//onMoved listener. fired when tab is moved into the same window
browser.tabs.onMoved.addListener(function(tabId, moveInfo){
  var startIndex = moveInfo.fromIndex;
  var endIndex = moveInfo.toIndex;
  console.log(`Tab with id: ${tabId} moved from index: ${startIndex} to index: ${endIndex}`);
});
